diff -urN irchat-pj-2.4.24.21/OLD/irchat-pj-mode-line-format.el irchat-pj-2.4.24.22/OLD/irchat-pj-mode-line-format.el
--- irchat-pj-2.4.24.21/OLD/irchat-pj-mode-line-format.el	Thu Jan  1 09:00:00 1970
+++ irchat-pj-2.4.24.22/OLD/irchat-pj-mode-line-format.el	Fri Dec 17 23:36:38 1999
@@ -0,0 +1,300 @@
+;;;
+;;; irchat-pj-mode-line-format.el
+;;; last modify : Sun, 3 Jan 1999 by simm@irc.fan.gr.jp / irchat-PJ Project
+;;; (date format modification by simm@irc.fan.gr.jp, Sun, 27 Jun 1999)
+;;; see file irchat-copyright.el for change log and copyright info
+;;;
+
+(provide 'irchat-pj-mode-line-format)
+
+;;
+;; irchat-pj-Commands-mode-line-format
+;;
+
+(defvar irchat-pj-Commands-mode-line-format-default
+  (if (featurep 'meadow)
+      '("" irchat-away-indicator irchat-freeze-indicator ""
+        ((if (boundp 'MULE) mc-flag kanji-flag)
+         ((minibuffer-window-selected
+           (display-minibuffer-mode "m" " ") " ")
+          mw32-ime-mode-line-state-indicator))
+        " IRCHAT: Commands" irchat-private-indicator
+        " {" irchat-chanbuf-indicator "} "
+        irchat-nickname " on " irchat-servername
+        (skk-mode skk-input-mode-string)
+        " -%-")
+    '("" irchat-away-indicator irchat-freeze-indicator ""
+      ((if (boundp 'MULE) mc-flag kanji-flag)
+       ((minibuffer-window-selected
+         (display-minibuffer-mode "m" " ") " ")
+        "["
+        (minibuffer-window-selected
+         (display-minibuffer-mode
+          mode-line-egg-mode-in-minibuffer
+          mode-line-egg-mode)
+         mode-line-egg-mode)
+        " ] " mode-line-canna-mode))
+      " IRCHAT: Commands" irchat-private-indicator
+      " {" irchat-chanbuf-indicator "} "
+      irchat-nickname " on " irchat-servername
+      (skk-mode skk-input-mode-string)
+      " -%-")))
+
+(defvar irchat-pj-Commands-mode-line-format-for-egg
+  '("" irchat-away-indicator irchat-freeze-indicator ""
+    ((if (boundp 'MULE) mc-flag kanji-flag)
+     ((minibuffer-window-selected
+       (display-minibuffer-mode "m" " ") " ")
+      "["
+      (minibuffer-window-selected
+       (display-minibuffer-mode
+	mode-line-egg-mode-in-minibuffer
+	mode-line-egg-mode)
+       mode-line-egg-mode)
+      " ]"))
+    " IRCHAT: Commands" irchat-private-indicator
+    " {" irchat-chanbuf-indicator "} "
+    irchat-nickname " on " irchat-servername " -%-"))
+
+(defvar irchat-pj-Commands-mode-line-format-for-canna
+  '("" irchat-away-indicator irchat-freeze-indicator ""
+    ((if (boundp 'MULE) mc-flag kanji-flag)
+     ((minibuffer-window-selected
+       (display-minibuffer-mode "m" " ") " ")
+      "-" mode-line-canna-mode))
+    " IRCHAT: Commands" irchat-private-indicator
+    " {" irchat-chanbuf-indicator "} "
+    irchat-nickname " on " irchat-servername " -%-"))
+
+(defvar irchat-pj-Commands-mode-line-format-for-mw32
+  '("" irchat-away-indicator irchat-freeze-indicator ""
+    ((if (boundp 'MULE) mc-flag kanji-flag)
+     ((minibuffer-window-selected
+       (display-minibuffer-mode "m" " ") " ")
+      mw32-ime-mode-line-state-indicator))
+    " IRCHAT: Commands" irchat-private-indicator
+    " {" irchat-chanbuf-indicator "} "
+    irchat-nickname " on " irchat-servername
+    " -%-"))
+
+(defvar irchat-pj-Commands-mode-line-format-simple
+  '("" irchat-away-indicator irchat-freeze-indicator ""
+    " IRCHAT: Commands" irchat-private-indicator
+    " {" irchat-chanbuf-indicator "} "
+    irchat-nickname " on " irchat-servername
+    (skk-mode skk-input-mode-string)
+    " -%-"))
+
+(defvar irchat-pj-Commands-mode-line-format-alternative
+  (if (featurep 'meadow)
+      '("" irchat-away-indicator irchat-freeze-indicator ""
+        ((if (boundp 'MULE) mc-flag kanji-flag)
+         ((minibuffer-window-selected
+           (display-minibuffer-mode "m" " ") " ")
+          mw32-ime-mode-line-state-indicator))
+        " irchat-pj: Commands" irchat-private-indicator
+        " <" irchat-servername "> " irchat-nickname
+        " (" irchat-chanbuf-indicator (skk-mode skk-input-mode-string) ")"
+        " -%-")
+    '("" irchat-away-indicator irchat-freeze-indicator ""
+      ((if (boundp 'MULE) mc-flag kanji-flag)
+       ((minibuffer-window-selected
+         (display-minibuffer-mode "m" " ") " ")
+        "["
+        (minibuffer-window-selected
+         (display-minibuffer-mode
+          mode-line-egg-mode-in-minibuffer
+          mode-line-egg-mode)
+         mode-line-egg-mode)
+        " ]"))
+      " irchat-pj: Commands" irchat-private-indicator
+      " <" irchat-servername "> " irchat-nickname
+      " (" irchat-chanbuf-indicator (skk-mode skk-input-mode-string) ")"
+      " -%-")))
+
+(defvar irchat-pj-Commands-mode-line-format-alt-egg
+  '("" irchat-away-indicator irchat-freeze-indicator ""
+    ((if (boundp 'MULE) mc-flag kanji-flag)
+     ((minibuffer-window-selected
+       (display-minibuffer-mode "m" " ") " ")
+      "["
+      (minibuffer-window-selected
+       (display-minibuffer-mode
+	mode-line-egg-mode-in-minibuffer
+	mode-line-egg-mode)
+       mode-line-egg-mode)
+      " ] " mode-line-canna-mode))
+    " irchat-pj: Commands" irchat-private-indicator
+    " <" irchat-servername "> " irchat-nickname
+    " (" irchat-chanbuf-indicator ")"
+    " -%-"))
+
+(defvar irchat-pj-Commands-mode-line-format-alt-canna
+  '("" irchat-away-indicator irchat-freeze-indicator ""
+    ((if (boundp 'MULE) mc-flag kanji-flag)
+     ((minibuffer-window-selected
+       (display-minibuffer-mode "m" " ") " ")
+      "-" mode-line-canna-mode))
+    " irchat-pj: Commands" irchat-private-indicator
+    " <" irchat-servername "> " irchat-nickname
+    " (" irchat-chanbuf-indicator (skk-mode skk-input-mode-string) ")"
+    " -%-"))
+
+(defvar irchat-pj-Commands-mode-line-format-alt-mw32
+  '("" irchat-away-indicator irchat-freeze-indicator ""
+    ((if (boundp 'MULE) mc-flag kanji-flag)
+     ((minibuffer-window-selected
+       (display-minibuffer-mode "m" " ") " ")
+        mw32-ime-mode-line-state-indicator))
+    " irchat-pj: Commands" irchat-private-indicator
+    " <" irchat-servername "> " irchat-nickname
+    " (" irchat-chanbuf-indicator  ")"
+    " -%-"))
+
+(defvar irchat-pj-Commands-mode-line-format-alt-simple
+  '("" irchat-away-indicator irchat-freeze-indicator ""
+    " irchat-pj: Commands" irchat-private-indicator
+    " <" irchat-servername "> " irchat-nickname
+    " (" irchat-chanbuf-indicator (skk-mode skk-input-mode-string) ")"
+    " -%-"))
+
+(defvar irchat-pj-Commands-mode-line-format-minor-mode
+  '("" irchat-away-indicator irchat-freeze-indicator ""
+    " irchat-pj: Commands" irchat-private-indicator
+    " <" irchat-servername "> " irchat-nickname
+    " (" irchat-chanbuf-indicator minor-mode-alist ")"
+    " -%-"))
+
+(defvar irchat-pj-Commands-mode-line-format 'irchat-pj-Commands-mode-line-format-default
+  "Mode line format for irchat-pj Command buffer.
+
+We irchat-PJ project provides below:
+\(for most use\)
+  irchat-pj-Commands-mode-line-format-default
+  irchat-pj-Commands-mode-line-format-alternative
+\(for minor-mode kana-kanji converting system, like SKK10\)
+  irchat-pj-Commands-mode-line-format-minor-mode
+\(for non-kana-kanji-conversion, or SKK user\)
+  irchat-pj-Commands-mode-line-format-simple
+  irchat-pj-Commands-mode-line-format-alt-simple
+\(for Wnn user\)
+  irchat-pj-Commands-mode-line-format-for-egg
+  irchat-pj-Commands-mode-line-format-alt-egg
+\(for Canna user\)
+  irchat-pj-Commands-mode-line-format-for-canna
+  irchat-pj-Commands-mode-line-format-alt-canna
+So, choose above, or select your defined mode line.
+
+ex.
+\(setq irchat-pj-Commands-mode-line-format 'irchat-pj-Commands-mode-line-format-minor-mode\)
+
+Default is irchat-pj-Commands-mode-line-format-default.
+")
+
+;;
+;; irchat-pj-Dialogue-mode-line-format
+;;
+
+(defvar irchat-pj-Dialogue-mode-line-format-default
+  '("" irchat-away-indicator irchat-freeze-indicator
+    " {" irchat-chanbufs-indicator "} "
+    (-3 . "%p") " -%-"))
+
+(defvar irchat-pj-Dialogue-mode-line-format-alternative
+  '("" irchat-away-indicator irchat-freeze-indicator
+    " (" irchat-chanbufs-indicator ") "
+    (-3 . "%p") " -%-"))
+
+(defvar irchat-pj-Dialogue-mode-line-format-minor-mode
+  '("" irchat-away-indicator irchat-freeze-indicator
+    " (" irchat-chanbufs-indicator minor-mode-alist ") "
+    (-3 . "%p") " -%-"))
+
+(defvar irchat-pj-Dialogue-mode-line-format 'irchat-pj-Dialogue-mode-line-format-default
+  "Mode line format for irchat-pj Dialogue buffer.
+
+We irchat-PJ project provides below:
+  irchat-pj-Dialogue-mode-line-format-default
+  irchat-pj-Dialogue-mode-line-format-alternative
+  irchat-pj-Dialogue-mode-line-format-minor-mode
+So, choose above, or select your defined mode line.
+
+ex.
+\(setq irchat-pj-Dialogue-mode-line-format 'irchat-pj-Dialogue-mode-line-format-minor-mode\)
+
+Default is irchat-pj-Dialogue-mode-line-format-default.
+")
+
+;;
+;; irchat-pj-Other-mode-line-format
+;;
+
+(defvar irchat-pj-Other-mode-line-format-default
+  '("" irchat-away-indicator "-"
+    " {" irchat-chanbufs-indicator "} "
+    (-3 . "%p") " -%-"))
+
+(defvar irchat-pj-Other-mode-line-format-alternative
+  '("" irchat-away-indicator "-"
+    " (" irchat-chanbufs-indicator ") "
+    (-3 . "%p") " -%-"))
+
+(defvar irchat-pj-Other-mode-line-format-minor-mode
+  '("" irchat-away-indicator "-"
+    " (" irchat-chanbufs-indicator minor-mode-alist ") "
+    (-3 . "%p") " -%-"))
+
+(defvar irchat-pj-Other-mode-line-format 'irchat-pj-Other-mode-line-format-default
+  "Mode line format for irchat-pj Other buffer.
+
+We irchat-PJ project provides below:
+  irchat-pj-Other-mode-line-format-default
+  irchat-pj-Other-mode-line-format-alternative
+  irchat-pj-Other-mode-line-format-minor-mode
+So, choose above, or select your defined mode line.
+
+ex.
+\(setq irchat-pj-Other-mode-line-format 'irchat-pj-Other-mode-line-format-minor-mode\)
+
+Default is irchat-pj-Other-mode-line-format-default.
+")
+
+;;
+;; irchat-pj-Channel-mode-line-format
+;;
+
+(defvar irchat-pj-Channel-mode-line-format-default
+  '("" irchat-beep-indicator-local irchat-freeze-indicator-local
+    irchat-suppress-indicator-local
+    "IRCHAT: Current" 
+    " {" irchat-chanbuf-indicator "} "
+    (-3 . "%p") " -%-"))
+
+(defvar irchat-pj-Channel-mode-line-format-alternative
+  '("" irchat-beep-indicator-local irchat-freeze-indicator-local
+    irchat-suppress-indicator-local
+    "irchat-pj: Current" 
+    " (" irchat-chanbuf-indicator ") "
+    (-3 . "%p") " -%-"))
+
+(defvar irchat-pj-Channel-mode-line-format-minor-mode
+  '("" irchat-beep-indicator-local irchat-freeze-indicator-local
+    irchat-suppress-indicator-local
+    "irchat-pj: Current" 
+    " (" irchat-chanbuf-indicator minor-mode-alist ") "
+    (-3 . "%p") " -%-"))
+
+(defvar irchat-pj-Channel-mode-line-format 'irchat-pj-Channel-mode-line-format-default
+  "Mode line format for irchat-pj Channel buffer.
+
+We irchat-PJ project provides below:
+  irchat-pj-Channel-mode-line-format-default
+  irchat-pj-Channel-mode-line-format-alternative
+  irchat-pj-Channel-mode-line-format-minor-mode
+So, choose above, or select your defined mode line.
+
+ex.
+\(setq irchat-pj-Channel-mode-line-format 'irchat-pj-Channel-mode-line-format-minor-mode\)
+
+Default is irchat-pj-Channel-mode-line-format-default.
+")
diff -urN irchat-pj-2.4.24.21/doc/FAQ-irchat-PJ.txt irchat-pj-2.4.24.22/doc/FAQ-irchat-PJ.txt
--- irchat-pj-2.4.24.21/doc/FAQ-irchat-PJ.txt	Sat Dec 18 04:00:40 1999
+++ irchat-pj-2.4.24.22/doc/FAQ-irchat-PJ.txt	Sun Jul 21 02:08:23 2002
@@ -61,7 +61,6 @@
     $B$+$iF~<j$G$-$^$9(B. $B0BDjHG$H:G?7HG$rMQ0U$7$F$*$j$^$9$,(B,
     $B0BDjHG$h$j$b:G?7HG$N$[$&$,0BDj$7$F$k$H$$$&$3$H$b$"$j$^$9(B (^^;
     $B$^$?(B, $B%_%i!<%5%$%H$H$7$F(B, $BEv%W%m%8%'%/%H$,3NG'$7$F$$$k$H$3$m$G(B
-        (WWW) http://www.isoternet.org/~simm/
         (FTP) ftp://ftp.KU3G.org/pub/irchat-pj/
         (FTP) ftp://ftp.madoka.org/pub/irchat-pj/
         (FTP) ftp://ftp.win.ne.jp/pub/network/irc/irchat-pj/
@@ -73,21 +72,16 @@
     $B$N$$$:$l$+$r3N$+$a$F$$$?$@$1$l$P$o$+$j$^$9(B.
 
     IRC $B>e$G$O(B, Friend Chat $B$N(B #irchat-pj $B%A%c%M%k$N%H%T%C%/$r$4(B
-    $BMw$/$@$5$$(B. $B$^$?(B, $B%P!<%8%g%s%"%C%W$,$"$C$?:]$K$O(B, IRCnet $B$N(B
-    #KU3G $B$N%H%T%C%/$K$b5-=R$7$F$*$j$^$9(B.
+    $BMw$/$@$5$$(B. Friend Chat $B$N(B $B3F%A%c%M%k$N%H%T%C%/$O(B,
+      http://irc.fan.gr.jp/list.html 
+    $B$G3NG'$G$-$^$9(B.
+
     $B$J$*(B, Friend Chat $B$K4X$7$F$O(B, $B2<$N!V6l>p!&MWK>!&%P%0Js9p@h$O(B?$B!W(B
     $B$K>R2p$7$F$*$j$^$9$N$G(B, $B$=$A$i$r$4Mw$/$@$5$$(B.
 
 $B!&%$%s%9%H!<%kJ}K!$O(B?
 
     INSATLL.irchat-pj $B$r;2>H$/$@$5$$(B.
-    Vine Linux $B$G(B XEmacs $B$r$4MxMQ$NJ}$O(B, Vine Plus $B$K%Q%C%1!<%8$,(B
-    $B$4$6$$$^$9$N$G(B, $B$=$l$r$4MxMQ$/$@$5$$(B.
-
-$B!&$[$+$N%Q%C%1!<%8$O$J$$$N(B?
-
-    $B:#$N$H$3$m$"$j$^$;$s(B. $B$[$+$N%Q%C%1!<%8$r$D$/$C$F$d$m$&$H$$$&J}$O(B,
-    $B@'Hs(B simm@irc.fan.gr.jp $B$^$G$4O"Mm$r(B.
 
 $B!&;H$$J}$O(B?
 
@@ -125,8 +119,8 @@
     IRC $B>e(B, $B$b$7$/$O%a!<%k$G$NMWK>!&Js9p$r$*BT$A$7$F$*$j$^$9(B.
 
     IRC $B$G$O(B, $B%5%]!<%H;~4V$,8a8e(B11$B;~:"$K8B$i$l$^$9$,(B, $B8x<0%5%]!<(B
-    $B%H%A%c%M%k$H$7$F(B, Friend Chat (irc.friend.td.nu:6667) $B>e$K(B
-    #irchat-pj $B$rMQ0U$7$F$*$j$^$9(B. $B$J$k$Y$/$3$3$G$*4j$$$7$^$9(B.
+    $B%H%A%c%M%k$H$7$F(B, Friend Chat (irc.friend.td.nu:6660-6669)$B>e(B
+    $B$K(B #irchat-pj $B$rMQ0U$7$F$*$j$^$9(B. $B$J$k$Y$/$3$3$G$*4j$$$7$^$9(B.
     (Friend Chat $B$N>\:Y$O(B http://www.friend.td.nu/ $B;2>H(B)
 
     IRCnet $B$K$O8x<0%A%c%M%k$rMQ0U$7$F$*$j$^$;$s$,(B, #KU3G $B$"$?$j(B
diff -urN irchat-pj-2.4.24.21/doc/INSTALL.irchat-pj irchat-pj-2.4.24.22/doc/INSTALL.irchat-pj
--- irchat-pj-2.4.24.21/doc/INSTALL.irchat-pj	Wed Jan 19 21:08:16 2000
+++ irchat-pj-2.4.24.22/doc/INSTALL.irchat-pj	Sun Jul 21 02:07:19 2002
@@ -81,6 +81,5 @@
    $B$H$-$O(B "XEMACS=..." $B$N5-=R$OI,MW$"$j$^$;$s(B.
 
 5.$B$=$NB>$N%$%s%9%H!<%kJ}K!(B
-  Vine Plus $B$K(B XEmacs $BMQ(B irchat-pj $B$N%Q%C%1!<%8$,MQ0U$5$l$F$*$j$^$9(B.
-  Vine Linux $B$r$4MxMQ$NJ}$O(B, $BB>$N(B rpm $B%Q%C%1!<%8F1MM4JC1$K%$%s%9%H!<%k(B
-  $B$9$k$3$H$,$G$-$^$9(B.
+  irchat-pj $B%Q%C%1!<%8$,B8:_$9$k%G%#%9%H%j%S%e!<%7%g%s$r$*;H$$$N>l9g(B,
+  $B3F%G%#%9%H%j%S%e!<%7%g%s$N%$%s%9%H!<%kJ}K!$K$7$?$,$C$F$/$@$5$$(B.
diff -urN irchat-pj-2.4.24.21/doc/README.irchat-pj irchat-pj-2.4.24.22/doc/README.irchat-pj
--- irchat-pj-2.4.24.21/doc/README.irchat-pj	Tue May  2 02:41:25 2000
+++ irchat-pj-2.4.24.22/doc/README.irchat-pj	Sun Jul 21 02:39:06 2002
@@ -2,7 +2,7 @@
 
 Subject:      irchat-pj $B$NMxMQJ}K!(B
 Author:       $B$7$^$@(B $B$_$D$N$V(B <simm@irc.fan.gr.jp>
-Date:         1999$BG/(B12$B7n(B20$BF|(B($B7n(B)
+Date:         2002$BG/(B7$B7n(B21$BF|(B($BF|(B)
 Organization: irchat-PJ Project
 
 ----------------
@@ -25,7 +25,7 @@
  1. $BF|K\8l%3!<%I$N@_Dj(B
  2. $BH>3Q%+%J$N07$$(B
  3. $B5/F0;~$N(B nickname $B$NJ#?t;XDj(B
- 4. $BF~NO%P%C%U%!$N%b!<%I%i%$%s(B
+ 4. $B%b!<%I%i%$%s(B
  5. Sound $B5!G=(B
  6. $BN,8lE83+5!G=(B
  7. $B%a%C%;!<%80l@FAw?.(B
@@ -115,33 +115,35 @@
 
 ----------------
 
-4.$BF~NO%P%C%U%!$N%b!<%I%i%$%s(B
+4.$B%b!<%I%i%$%s(B
 
 irchat-2.4jp24g $B$G$O(B, $BF|K\8lF~NO<jCJ$H$7$F(B Canna $B$d(B SKK10 $B$rMxMQ(B
 $B$9$k$H(B, $BF~NO%P%C%U%!$N%b!<%I%i%$%s$r8+$F$b(B, $BF|K\8lF~NO%b!<%I$J$N(B
-$B$+$I$&$+$NH=JL$,$D$-$^$;$s(B. $B$=$3$G(B, Canna $B$d(B SKK10 $B$G$bF~NO%b!<(B
-$B%I$N>u67$rI=<($9$k$h$&$K$9$k$H$H$b$K(B, $B%b!<%I%i%$%s<+BN$rJQ99$G$-(B
-$B$k$h$&$K$7$^$7$?(B. $BJQ?t(B irchat-pj-Commands-mode-line-format $B$r(B, $B<!(B
-$B$N$$$:$l$+$K@_Dj$9$k$3$H$G(B, $BJQ99$G$-$^$9(B.
-
-$BHFMQ(B : 'irchat-pj-Commands-mode-line-format-default
-       'irchat-pj-Commands-mode-line-format-alternative
-SKK10$BEy%^%$%J!<%b!<%I$rMxMQ$7$F$$$k$b$N(B:
-       'irchat-pj-Commands-mode-line-format-minor-mode
-SKK9 : 'irchat-pj-Commands-mode-line-format-simple
-       'irchat-pj-Commands-mode-line-format-alt-simple
-Egg  : 'irchat-pj-Commands-mode-line-format-for-egg
-       'irchat-pj-Commands-mode-line-format-alt-egg
-Canna: 'irchat-pj-Commands-mode-line-format-for-canna
-       'irchat-pj-Commands-mode-line-format-alt-canna
-Meadow$B;HMQ;~$K$*$1$k(BIME:
-       'irchat-pj-Commands-mode-line-format-for-mw32
-       'irchat-pj-Commands-mode-line-format-alt-mw32
-
-$B$J$*(B, $B%G%U%)%k%H$O(B
-(setq irchat-pj-Commands-mode-line-format
-      'irchat-pj-Commands-mode-line-format-default)
-$B$G$9(B.
+$B$+$I$&$+$NH=JL$,$D$-$^$;$s(B. $B$3$l$O(B, irchat$BB&$GFH<+$K%b!<%I%i%$%s(B
+$B$rDj5A$7$F$*$j(B, $BF|K\8lF~NO%b!<%II=<(@_Dj$,>e=q$-$7$F$7$^$&$?$a$K(B
+$B5/$3$kLdBj$G$9(B.
+
+$B=>Mh$N(B irchat-pj $B$G$O(B, irchat $B$N%b!<%I%i%$%s$KF|K\8lF~NO%b!<%I$r(B
+$BDI2C$9$k$3$H$GBP1~$7$F$*$j$^$7$?$,(B, $B$3$NJ}K!$@$H(B, $BF|K\8lF~NO%7%9(B
+$B%F%`$4$H$K8DJLBP1~$9$kI,MW$,$"$j(B, $B%a%s%F%J%s%9%3%9%H$bGO</$K$J$j(B
+$B$^$;$s(B. $B$^$?(B, $B;~9o$d%P%C%F%jMFNLEy(B, $BI8=`0J30$N>pJs$r%b!<%I%i%$%s(B
+$B$KI=<($5$;$F$$$F$b(B, irchat-pj $B$@$1$OL58z$K$J$k$H$$$&LdBj$b$"$j$^(B
+$B$7$?(B.
+
+irchat-pj-2.4.24.22 $B0J9_$G$O(B, $BI,MWItJ,$N$_%b!<%I%i%$%s$rJQ99$9$k(B
+$B$3$H$K$h$j(B, $B>e5-LdBj$r2r7h$7$^$7$?(B. $B@_Dj$O$H$/$K$9$kI,MW$"$j$^$;(B
+$B$s$,(B, $B%b!<%I%i%$%s$rJQ99$7$?$$>l9g$O(B, $BJQ?t(B
+
+  irchat-pj-modeline-Command-buffer
+  irchat-pj-modeline-Dialogue-buffer
+  irchat-pj-modeline-Others-buffer
+  irchat-pj-modeline-Channel-buffer
+
+$B$r3F<+@_Dj$7$F$/$@$5$$(B. $B3F%P%C%U%!$KBP1~$7$?JQ?t$G(B, $B$3$l$i$NCM$O(B
+
+  mode-line-buffer-identification
+
+$B$H$7$FMxMQ$5$l$^$9(B.
 
 ----------------
 
diff -urN irchat-pj-2.4.24.21/irchat-commands.el irchat-pj-2.4.24.22/irchat-commands.el
--- irchat-pj-2.4.24.21/irchat-commands.el	Fri Jul 19 02:04:44 2002
+++ irchat-pj-2.4.24.22/irchat-commands.el	Sat Jul 20 21:19:37 2002
@@ -26,7 +26,6 @@
 	(set-window-point (get-buffer-window irchat-Channel-buffer)
 			  (point-max)))
     (setq irchat-freeze nil)
-    (setq irchat-freeze-indicator "-")
     (if (get-buffer-window irchat-Dialogue-buffer)
 	(let ((owin (selected-window)) win)
 	  (if (one-window-p)
@@ -689,9 +688,6 @@
   "Toggle the automatic scrolling of the Dialogue window."
   (interactive)
   (setq irchat-freeze (not irchat-freeze))
-  (if irchat-freeze
-      (setq irchat-freeze-indicator "F")
-    (setq irchat-freeze-indicator "-"))
   (set-buffer-modified-p (buffer-modified-p)))
 
 (defun irchat-Channel-freeze (&optional value)
@@ -703,10 +699,7 @@
 	   (setq irchat-freeze-local t))
 	  ((eq value 'off)
 	   (setq irchat-freeze-local nil)))
-    (setq irchat-freeze-local (not irchat-freeze-local))
-    (if irchat-freeze-local
-	(setq irchat-freeze-indicator-local "F")
-      (setq irchat-freeze-indicator-local "-")))
+    (setq irchat-freeze-local (not irchat-freeze-local)))
   (set-buffer-modified-p (buffer-modified-p)))
 
 
@@ -719,10 +712,7 @@
 	   (setq irchat-beep-local t))
 	  ((eq value 'off)
 	   (setq irchat-beep-local nil)))
-    (setq irchat-beep-local (not irchat-beep-local))
-    (if irchat-beep-local
-	(setq irchat-beep-indicator-local "B")
-      (setq irchat-beep-indicator-local "-")))
+    (setq irchat-beep-local (not irchat-beep-local)))
   (set-buffer-modified-p (buffer-modified-p)))
 
 
@@ -735,10 +725,7 @@
 	   (setq irchat-suppress-local t))
 	  ((eq value 'off)
 	   (setq irchat-suppress-local nil)))
-    (setq irchat-suppress-local (not irchat-suppress-local))
-    (if irchat-suppress-local
-	(setq irchat-suppress-indicator-local "S")
-      (setq irchat-suppress-indicator-local " ")))
+    (setq irchat-suppress-local (not irchat-suppress-local)))
   (set-buffer-modified-p (buffer-modified-p)))
 
 
diff -urN irchat-pj-2.4.24.21/irchat-globals.el irchat-pj-2.4.24.22/irchat-globals.el
--- irchat-pj-2.4.24.21/irchat-globals.el	Sun Dec 13 10:40:27 1998
+++ irchat-pj-2.4.24.22/irchat-globals.el	Sat Jul 20 21:20:13 2002
@@ -45,7 +45,6 @@
 
 (defvar irchat-polling)
 
-(defvar irchat-away-indicator)
 (defvar irchat-nick-alist)
 (defvar irchat-channel-alist)
 (defvar irchat-channel-filter)
diff -urN irchat-pj-2.4.24.21/irchat-handle.el irchat-pj-2.4.24.22/irchat-handle.el
--- irchat-pj-2.4.24.21/irchat-handle.el	Wed Sep  6 21:06:57 2000
+++ irchat-pj-2.4.24.22/irchat-handle.el	Sat Jul 20 21:19:56 2002
@@ -885,16 +885,16 @@
 
 (defun irchat-handle-305 (prefix me msg) ; RPL_UNAWAY
   "Handle the 305 reply, UNAWAY reply"
-  (if (string-equal irchat-away-indicator "A")
+  (if irchat-pj-away-p
       (progn
-	(setq irchat-away-indicator "-")
+	(setq irchat-pj-away-p nil)
 	(irchat-maybe-poll)
 	(irchat-insert0 (format "*** %s (%s)\n"
 				msg (current-time-string))))))
 
 (defun irchat-handle-306 (prefix me msg) ; RPL_NOWAWAY
   "Handle the 306 reply, NOWAWAY reply"
-  (setq irchat-away-indicator "A")
+  (setq irchat-pj-away-p t)
   (irchat-insert0 (format "*** %s (%s)\n"
 			  msg (current-time-string))))
 
diff -urN irchat-pj-2.4.24.21/irchat-pj-mode-line-format.el irchat-pj-2.4.24.22/irchat-pj-mode-line-format.el
--- irchat-pj-2.4.24.21/irchat-pj-mode-line-format.el	Fri Dec 17 23:36:38 1999
+++ irchat-pj-2.4.24.22/irchat-pj-mode-line-format.el	Thu Jan  1 09:00:00 1970
@@ -1,300 +0,0 @@
-;;;
-;;; irchat-pj-mode-line-format.el
-;;; last modify : Sun, 3 Jan 1999 by simm@irc.fan.gr.jp / irchat-PJ Project
-;;; (date format modification by simm@irc.fan.gr.jp, Sun, 27 Jun 1999)
-;;; see file irchat-copyright.el for change log and copyright info
-;;;
-
-(provide 'irchat-pj-mode-line-format)
-
-;;
-;; irchat-pj-Commands-mode-line-format
-;;
-
-(defvar irchat-pj-Commands-mode-line-format-default
-  (if (featurep 'meadow)
-      '("" irchat-away-indicator irchat-freeze-indicator ""
-        ((if (boundp 'MULE) mc-flag kanji-flag)
-         ((minibuffer-window-selected
-           (display-minibuffer-mode "m" " ") " ")
-          mw32-ime-mode-line-state-indicator))
-        " IRCHAT: Commands" irchat-private-indicator
-        " {" irchat-chanbuf-indicator "} "
-        irchat-nickname " on " irchat-servername
-        (skk-mode skk-input-mode-string)
-        " -%-")
-    '("" irchat-away-indicator irchat-freeze-indicator ""
-      ((if (boundp 'MULE) mc-flag kanji-flag)
-       ((minibuffer-window-selected
-         (display-minibuffer-mode "m" " ") " ")
-        "["
-        (minibuffer-window-selected
-         (display-minibuffer-mode
-          mode-line-egg-mode-in-minibuffer
-          mode-line-egg-mode)
-         mode-line-egg-mode)
-        " ] " mode-line-canna-mode))
-      " IRCHAT: Commands" irchat-private-indicator
-      " {" irchat-chanbuf-indicator "} "
-      irchat-nickname " on " irchat-servername
-      (skk-mode skk-input-mode-string)
-      " -%-")))
-
-(defvar irchat-pj-Commands-mode-line-format-for-egg
-  '("" irchat-away-indicator irchat-freeze-indicator ""
-    ((if (boundp 'MULE) mc-flag kanji-flag)
-     ((minibuffer-window-selected
-       (display-minibuffer-mode "m" " ") " ")
-      "["
-      (minibuffer-window-selected
-       (display-minibuffer-mode
-	mode-line-egg-mode-in-minibuffer
-	mode-line-egg-mode)
-       mode-line-egg-mode)
-      " ]"))
-    " IRCHAT: Commands" irchat-private-indicator
-    " {" irchat-chanbuf-indicator "} "
-    irchat-nickname " on " irchat-servername " -%-"))
-
-(defvar irchat-pj-Commands-mode-line-format-for-canna
-  '("" irchat-away-indicator irchat-freeze-indicator ""
-    ((if (boundp 'MULE) mc-flag kanji-flag)
-     ((minibuffer-window-selected
-       (display-minibuffer-mode "m" " ") " ")
-      "-" mode-line-canna-mode))
-    " IRCHAT: Commands" irchat-private-indicator
-    " {" irchat-chanbuf-indicator "} "
-    irchat-nickname " on " irchat-servername " -%-"))
-
-(defvar irchat-pj-Commands-mode-line-format-for-mw32
-  '("" irchat-away-indicator irchat-freeze-indicator ""
-    ((if (boundp 'MULE) mc-flag kanji-flag)
-     ((minibuffer-window-selected
-       (display-minibuffer-mode "m" " ") " ")
-      mw32-ime-mode-line-state-indicator))
-    " IRCHAT: Commands" irchat-private-indicator
-    " {" irchat-chanbuf-indicator "} "
-    irchat-nickname " on " irchat-servername
-    " -%-"))
-
-(defvar irchat-pj-Commands-mode-line-format-simple
-  '("" irchat-away-indicator irchat-freeze-indicator ""
-    " IRCHAT: Commands" irchat-private-indicator
-    " {" irchat-chanbuf-indicator "} "
-    irchat-nickname " on " irchat-servername
-    (skk-mode skk-input-mode-string)
-    " -%-"))
-
-(defvar irchat-pj-Commands-mode-line-format-alternative
-  (if (featurep 'meadow)
-      '("" irchat-away-indicator irchat-freeze-indicator ""
-        ((if (boundp 'MULE) mc-flag kanji-flag)
-         ((minibuffer-window-selected
-           (display-minibuffer-mode "m" " ") " ")
-          mw32-ime-mode-line-state-indicator))
-        " irchat-pj: Commands" irchat-private-indicator
-        " <" irchat-servername "> " irchat-nickname
-        " (" irchat-chanbuf-indicator (skk-mode skk-input-mode-string) ")"
-        " -%-")
-    '("" irchat-away-indicator irchat-freeze-indicator ""
-      ((if (boundp 'MULE) mc-flag kanji-flag)
-       ((minibuffer-window-selected
-         (display-minibuffer-mode "m" " ") " ")
-        "["
-        (minibuffer-window-selected
-         (display-minibuffer-mode
-          mode-line-egg-mode-in-minibuffer
-          mode-line-egg-mode)
-         mode-line-egg-mode)
-        " ]"))
-      " irchat-pj: Commands" irchat-private-indicator
-      " <" irchat-servername "> " irchat-nickname
-      " (" irchat-chanbuf-indicator (skk-mode skk-input-mode-string) ")"
-      " -%-")))
-
-(defvar irchat-pj-Commands-mode-line-format-alt-egg
-  '("" irchat-away-indicator irchat-freeze-indicator ""
-    ((if (boundp 'MULE) mc-flag kanji-flag)
-     ((minibuffer-window-selected
-       (display-minibuffer-mode "m" " ") " ")
-      "["
-      (minibuffer-window-selected
-       (display-minibuffer-mode
-	mode-line-egg-mode-in-minibuffer
-	mode-line-egg-mode)
-       mode-line-egg-mode)
-      " ] " mode-line-canna-mode))
-    " irchat-pj: Commands" irchat-private-indicator
-    " <" irchat-servername "> " irchat-nickname
-    " (" irchat-chanbuf-indicator ")"
-    " -%-"))
-
-(defvar irchat-pj-Commands-mode-line-format-alt-canna
-  '("" irchat-away-indicator irchat-freeze-indicator ""
-    ((if (boundp 'MULE) mc-flag kanji-flag)
-     ((minibuffer-window-selected
-       (display-minibuffer-mode "m" " ") " ")
-      "-" mode-line-canna-mode))
-    " irchat-pj: Commands" irchat-private-indicator
-    " <" irchat-servername "> " irchat-nickname
-    " (" irchat-chanbuf-indicator (skk-mode skk-input-mode-string) ")"
-    " -%-"))
-
-(defvar irchat-pj-Commands-mode-line-format-alt-mw32
-  '("" irchat-away-indicator irchat-freeze-indicator ""
-    ((if (boundp 'MULE) mc-flag kanji-flag)
-     ((minibuffer-window-selected
-       (display-minibuffer-mode "m" " ") " ")
-        mw32-ime-mode-line-state-indicator))
-    " irchat-pj: Commands" irchat-private-indicator
-    " <" irchat-servername "> " irchat-nickname
-    " (" irchat-chanbuf-indicator  ")"
-    " -%-"))
-
-(defvar irchat-pj-Commands-mode-line-format-alt-simple
-  '("" irchat-away-indicator irchat-freeze-indicator ""
-    " irchat-pj: Commands" irchat-private-indicator
-    " <" irchat-servername "> " irchat-nickname
-    " (" irchat-chanbuf-indicator (skk-mode skk-input-mode-string) ")"
-    " -%-"))
-
-(defvar irchat-pj-Commands-mode-line-format-minor-mode
-  '("" irchat-away-indicator irchat-freeze-indicator ""
-    " irchat-pj: Commands" irchat-private-indicator
-    " <" irchat-servername "> " irchat-nickname
-    " (" irchat-chanbuf-indicator minor-mode-alist ")"
-    " -%-"))
-
-(defvar irchat-pj-Commands-mode-line-format 'irchat-pj-Commands-mode-line-format-default
-  "Mode line format for irchat-pj Command buffer.
-
-We irchat-PJ project provides below:
-\(for most use\)
-  irchat-pj-Commands-mode-line-format-default
-  irchat-pj-Commands-mode-line-format-alternative
-\(for minor-mode kana-kanji converting system, like SKK10\)
-  irchat-pj-Commands-mode-line-format-minor-mode
-\(for non-kana-kanji-conversion, or SKK user\)
-  irchat-pj-Commands-mode-line-format-simple
-  irchat-pj-Commands-mode-line-format-alt-simple
-\(for Wnn user\)
-  irchat-pj-Commands-mode-line-format-for-egg
-  irchat-pj-Commands-mode-line-format-alt-egg
-\(for Canna user\)
-  irchat-pj-Commands-mode-line-format-for-canna
-  irchat-pj-Commands-mode-line-format-alt-canna
-So, choose above, or select your defined mode line.
-
-ex.
-\(setq irchat-pj-Commands-mode-line-format 'irchat-pj-Commands-mode-line-format-minor-mode\)
-
-Default is irchat-pj-Commands-mode-line-format-default.
-")
-
-;;
-;; irchat-pj-Dialogue-mode-line-format
-;;
-
-(defvar irchat-pj-Dialogue-mode-line-format-default
-  '("" irchat-away-indicator irchat-freeze-indicator
-    " {" irchat-chanbufs-indicator "} "
-    (-3 . "%p") " -%-"))
-
-(defvar irchat-pj-Dialogue-mode-line-format-alternative
-  '("" irchat-away-indicator irchat-freeze-indicator
-    " (" irchat-chanbufs-indicator ") "
-    (-3 . "%p") " -%-"))
-
-(defvar irchat-pj-Dialogue-mode-line-format-minor-mode
-  '("" irchat-away-indicator irchat-freeze-indicator
-    " (" irchat-chanbufs-indicator minor-mode-alist ") "
-    (-3 . "%p") " -%-"))
-
-(defvar irchat-pj-Dialogue-mode-line-format 'irchat-pj-Dialogue-mode-line-format-default
-  "Mode line format for irchat-pj Dialogue buffer.
-
-We irchat-PJ project provides below:
-  irchat-pj-Dialogue-mode-line-format-default
-  irchat-pj-Dialogue-mode-line-format-alternative
-  irchat-pj-Dialogue-mode-line-format-minor-mode
-So, choose above, or select your defined mode line.
-
-ex.
-\(setq irchat-pj-Dialogue-mode-line-format 'irchat-pj-Dialogue-mode-line-format-minor-mode\)
-
-Default is irchat-pj-Dialogue-mode-line-format-default.
-")
-
-;;
-;; irchat-pj-Other-mode-line-format
-;;
-
-(defvar irchat-pj-Other-mode-line-format-default
-  '("" irchat-away-indicator "-"
-    " {" irchat-chanbufs-indicator "} "
-    (-3 . "%p") " -%-"))
-
-(defvar irchat-pj-Other-mode-line-format-alternative
-  '("" irchat-away-indicator "-"
-    " (" irchat-chanbufs-indicator ") "
-    (-3 . "%p") " -%-"))
-
-(defvar irchat-pj-Other-mode-line-format-minor-mode
-  '("" irchat-away-indicator "-"
-    " (" irchat-chanbufs-indicator minor-mode-alist ") "
-    (-3 . "%p") " -%-"))
-
-(defvar irchat-pj-Other-mode-line-format 'irchat-pj-Other-mode-line-format-default
-  "Mode line format for irchat-pj Other buffer.
-
-We irchat-PJ project provides below:
-  irchat-pj-Other-mode-line-format-default
-  irchat-pj-Other-mode-line-format-alternative
-  irchat-pj-Other-mode-line-format-minor-mode
-So, choose above, or select your defined mode line.
-
-ex.
-\(setq irchat-pj-Other-mode-line-format 'irchat-pj-Other-mode-line-format-minor-mode\)
-
-Default is irchat-pj-Other-mode-line-format-default.
-")
-
-;;
-;; irchat-pj-Channel-mode-line-format
-;;
-
-(defvar irchat-pj-Channel-mode-line-format-default
-  '("" irchat-beep-indicator-local irchat-freeze-indicator-local
-    irchat-suppress-indicator-local
-    "IRCHAT: Current" 
-    " {" irchat-chanbuf-indicator "} "
-    (-3 . "%p") " -%-"))
-
-(defvar irchat-pj-Channel-mode-line-format-alternative
-  '("" irchat-beep-indicator-local irchat-freeze-indicator-local
-    irchat-suppress-indicator-local
-    "irchat-pj: Current" 
-    " (" irchat-chanbuf-indicator ") "
-    (-3 . "%p") " -%-"))
-
-(defvar irchat-pj-Channel-mode-line-format-minor-mode
-  '("" irchat-beep-indicator-local irchat-freeze-indicator-local
-    irchat-suppress-indicator-local
-    "irchat-pj: Current" 
-    " (" irchat-chanbuf-indicator minor-mode-alist ") "
-    (-3 . "%p") " -%-"))
-
-(defvar irchat-pj-Channel-mode-line-format 'irchat-pj-Channel-mode-line-format-default
-  "Mode line format for irchat-pj Channel buffer.
-
-We irchat-PJ project provides below:
-  irchat-pj-Channel-mode-line-format-default
-  irchat-pj-Channel-mode-line-format-alternative
-  irchat-pj-Channel-mode-line-format-minor-mode
-So, choose above, or select your defined mode line.
-
-ex.
-\(setq irchat-pj-Channel-mode-line-format 'irchat-pj-Channel-mode-line-format-minor-mode\)
-
-Default is irchat-pj-Channel-mode-line-format-default.
-")
diff -urN irchat-pj-2.4.24.21/irchat-pj-modeline.el irchat-pj-2.4.24.22/irchat-pj-modeline.el
--- irchat-pj-2.4.24.21/irchat-pj-modeline.el	Thu Jan  1 09:00:00 1970
+++ irchat-pj-2.4.24.22/irchat-pj-modeline.el	Wed Jan 17 23:36:01 2001
@@ -0,0 +1,82 @@
+;;; irchat-pj-modeline.el --- Mode line format definition for irchat-pj
+
+;; Copyright (C) 2000 by Project Pure.
+
+;; Author: SHIMADA Mitsunobu <simm@irc.fan.gr.jp>
+;; Keywords: IRC, irchat-pj, mode-line-format
+
+;; $Id: irchat-pj-modeline.el,v 1.7 2001/01/17 14:36:01 simm Exp $
+
+;; This file is free software; you can redistribute it and/or modify
+;; it under the terms of the GNU General Public License as published by
+;; the Free Software Foundation; either version 2, or (at your option)
+;; any later version.
+
+;; This file is distributed in the hope that it will be useful,
+;; but WITHOUT ANY WARRANTY; without even the implied warranty of
+;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+;; GNU General Public License for more details.
+
+;; You should have received a copy of the GNU General Public License
+;; along with GNU Emacs; see the file COPYING.  If not, write to
+;; the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
+;; Boston, MA 02111-1307, USA.
+
+;;; Commentary:
+
+;; 
+
+;;; Code:
+
+;; AWAY / FREEZE indicator: used as `mode-line-modified'
+(defvar irchat-pj-modeline-global-status
+  '((irchat-pj-away-p "A" "-")
+    (irchat-freeze "F" "-"))
+  "Global mode line setting, to display IRC status.
+This variable is used as `mode-line-modified', in Commands/Dialogue/Others buffer.")
+(defvar irchat-pj-modeline-local-status
+  '((irchat-pj-away-p "A" "-")
+    (irchat-freeze-local "F" "-")
+    (irchat-beep-local "B" "-")
+    (irchat-suppress-local "S" "-"))
+  "Local mode line setting, to display IRC status.
+This variable is used as `mode-line-modified', in Channel buffer.")
+
+;; NICK / SERVER NAME / CHANNEL indicator: use as `mode-line-buffer-identification'
+(defvar irchat-pj-modeline-Command-buffer
+  '("irchat-pj: " irchat-nickname " <" irchat-servername "> " irchat-chanbuf-indicator)
+  "Local mode line setting, to display IRC informations in Commands buffer.
+This variable is used as `mode-line-buffer-identification'.")
+(defvar irchat-pj-modeline-Dialogue-buffer
+  '("" irchat-chanbufs-indicator)
+  "Local mode setting, to display IRC informations in Dialogue buffer.
+This variable is used as `mode-line-buffer-identification'.")
+(defvar irchat-pj-modeline-Others-buffer
+  '("" irchat-chanbufs-indicator)
+  "Local mode setting, to display IRC informations in Others buffer.
+This variable is used as `mode-line-buffer-identification'.")
+(defvar irchat-pj-modeline-Channel-buffer
+  '("irchat-pj: " irchat-chanbuf-indicator)
+  "Local mode setting, to display IRC informations in Channel buffer.
+This variable is used as `mode-line-buffer-identification'.")
+
+;; set mode line
+(defun irchat-pj-modeline-set (status buffer-info &optional user-define)
+  "Set mode-line-format"
+  ;; common behaviour
+  (setq mode-line-modified              status
+	mode-line-buffer-identification buffer-info)
+  ;; to emulate older irchat-pj-modeline.el
+  (and user-define
+       (boundp user-define)
+       (symbol-value user-define)
+       (let ((candidate (symbol-value user-define)))
+	 (if (not (symbolp candidate))
+	     (setq mode-line-format candidate)
+	   (if (boundp candidate)
+	       (setq mode-line-format (symbol-value candidate)))))))
+
+;; That's all
+(provide 'irchat-pj-modeline)
+
+;;; irchat-pj-modeline.el ends here
diff -urN irchat-pj-2.4.24.21/irchat-pj-version-string.el irchat-pj-2.4.24.22/irchat-pj-version-string.el
--- irchat-pj-2.4.24.21/irchat-pj-version-string.el	Fri Jul 19 02:03:15 2002
+++ irchat-pj-2.4.24.22/irchat-pj-version-string.el	Sat Jul 20 21:20:54 2002
@@ -21,7 +21,7 @@
 
 ;; constants and variables
 
-(defconst irchat-client-version-jp ".24.21[2002/07/19]")
+(defconst irchat-client-version-jp ".24.22[2002/07/21]")
 
 (defvar irchat-pj-version-string-hook nil
   "Hook for modification irchat-pj-version-string")
diff -urN irchat-pj-2.4.24.21/irchat.el irchat-pj-2.4.24.22/irchat.el
--- irchat-pj-2.4.24.21/irchat.el	Fri Jul 19 02:18:45 2002
+++ irchat-pj-2.4.24.22/irchat.el	Sat Jul 20 21:19:08 2002
@@ -3,8 +3,8 @@
 ;; irchat-2.4jp version by kick@wide.ad.jp (1994/03/17 - 1998/12/21)
 ;; Copyright (C) 1994,1995,1996,1997,1998 KIKUCHI Takahiro
 
-;; irchat-pj 2.4.24.x version by simm@irc.fan.gr.jp (1999/01/16-2000/01/19)
-;; Copyright (C) 1998-2000 irchat-PJ Project
+;; irchat-pj 2.4.24.x version by simm@irc.fan.gr.jp (1999/01/16-2002/07/19)
+;; Copyright (C) 1998-2002 irchat-PJ Project
 
 ;; modified by simm@irc.fan.gr.jp, Wed, 05 Jan 2000 02:51:10 +0900
 (or (fboundp 'defsubst)
@@ -16,7 +16,7 @@
 (require 'irchat-filter)
 (require 'irchat-vars)
 (require 'irchat-pj-jisx0201)
-(require 'irchat-pj-mode-line-format)
+(require 'irchat-pj-modeline)
 (require 'irchat-pj-coding-system)
 (require 'irchat-pj-version-string)
 (require 'irchat-pj-sound)
@@ -188,9 +188,6 @@
 (defvar irchat-buggy-emacs-pos-visible-in-window-p nil
   "*You should set non-nil if your emacs has buggy pos-visible-in-window-p.")
 
-(defvar irchat-away-indicator)
-(defvar irchat-freeze-indicator)
-
 (defvar irchat-trying-nickname nil
   "the nickname that I'm trying to be.")
 
@@ -253,10 +250,6 @@
 (defvar irchat-chanbufs-indicator "No channel"
   "The channel buffers list, \"pretty-printed.\"")
 
-(defvar irchat-private-indicator nil
-  "A string displayed in the mode line indicating that user is
-currently engaged in a one-to-one conversation.")
-
 (defvar irchat-polling nil
   "T when we are automatically polling the server.")
 
@@ -634,28 +627,15 @@
       (setq irchat-old-window-configuration
 	    (current-window-configuration)))
   (set-buffer irchat-Command-buffer)
-  (setq mode-line-process (format " {%s}" irchat-server))
   (let ((buffer-read-only nil))
     (erase-buffer)
     (sit-for 0))
   (make-variable-buffer-local 'irchat-freeze-local)
   (set-default 'irchat-freeze-local irchat-default-freeze-local)
-  (make-variable-buffer-local 'irchat-freeze-indicator-local)
-  (if irchat-default-freeze-local
-      (set-default 'irchat-freeze-indicator-local "F")
-    (set-default 'irchat-freeze-indicator-local "-"))
   (make-variable-buffer-local 'irchat-beep-local)
   (set-default 'irchat-beep-local irchat-default-beep-local)
-  (make-variable-buffer-local 'irchat-beep-indicator-local)
-  (if irchat-default-beep-local
-      (set-default 'irchat-beep-indicator-local "B")
-    (set-default 'irchat-beep-indicator-local "-"))
   (make-variable-buffer-local 'irchat-suppress-local)
   (set-default 'irchat-suppress-local irchat-default-suppress-local)
-  (make-variable-buffer-local 'irchat-suppress-indicator-local)
-  (if irchat-default-suppress-local
-      (set-default 'irchat-suppress-indicator-local "S")
-    (set-default 'irchat-suppress-indicator-local " "))
   (make-variable-buffer-local 'irchat-previous-pattern)
   (irchat-Dialogue-setup-buffer)
   (irchat-Others-setup-buffer)
@@ -722,17 +702,16 @@
   (define-abbrev-table 'irchat-pj-abbrev-table ())
 
   (setq irchat-nick-alist (list (list irchat-nickname))
-	mode-line-modified "--- "
 	major-mode 'irchat-Command-mode
-	mode-name "IRCHAT Commands"
+	mode-name "IRC Commands"
 	irchat-privmsg-partner nil
-	irchat-private-indicator nil
-	irchat-away-indicator "-"
-	irchat-freeze-indicator "-"
+	irchat-pj-away-p nil
 	;; modified by negi@KU3G.org, 1 Jun 1999
-	local-abbrev-table irchat-pj-abbrev-table
-	;; modified by simm@irc.fan.gr.jp, 23 Jan 1999
-	mode-line-format (symbol-value irchat-pj-Commands-mode-line-format))
+	local-abbrev-table irchat-pj-abbrev-table)
+  (irchat-pj-modeline-set
+   irchat-pj-modeline-global-status
+   irchat-pj-modeline-Command-buffer
+   'irchat-pj-modeline-Command)
   (use-local-map irchat-Command-mode-map)
   (if irchat-blink-parens
       nil
@@ -748,11 +727,12 @@
 Instead, these commands are available:
 \\{irchat-Dialogue-mode-map}"
   (kill-all-local-variables)
-  (setq mode-line-modified "--- "
-	major-mode 'irchat-Dialogue-mode
-	mode-name "IRCHAT Dialogue"
-	;; modified by simm@irc.fan.gr.jp, 23 Jan 1999
-	mode-line-format (symbol-value irchat-pj-Dialogue-mode-line-format))
+  (setq major-mode 'irchat-Dialogue-mode
+	mode-name "IRC Dialogue")
+  (irchat-pj-modeline-set
+   irchat-pj-modeline-global-status
+   irchat-pj-modeline-Dialogue-buffer
+   'irchat-pj-modeline-Dialogue)
   (use-local-map irchat-Dialogue-mode-map)
   (set-buffer irchat-Dialogue-buffer)
   (setq buffer-read-only t)
@@ -765,11 +745,12 @@
 Instead, these commands are available:
 \\{irchat-Others-mode-map}"
   (kill-all-local-variables)
-  (setq mode-line-modified "--- "
-	major-mode 'irchat-Others-mode
-	mode-name "IRCHAT Others"
-	;; modified by simm@irc.fan.gr.jp, 23 Jan 1999
-	mode-line-format (symbol-value irchat-pj-Other-mode-line-format))
+  (setq major-mode 'irchat-Others-mode
+	mode-name "IRC Others")
+  (irchat-pj-modeline-set
+   irchat-pj-modeline-global-status
+   irchat-pj-modeline-Others-buffer
+   'irchat-pj-modeline-Others)
   (use-local-map irchat-Others-mode-map)
   (set-buffer irchat-Others-buffer)
   (setq buffer-read-only t)
@@ -782,11 +763,12 @@
 Instead, these commands are available:
 \\{irchat-Channel-mode-map}"
   (kill-all-local-variables)
-  (setq mode-line-modified "--- "
-	major-mode 'irchat-Channel-mode
-	mode-name "IRCHAT Current channel"
-	;; modified by simm@irc.fan.gr.jp, 23 Jan 1999
-	mode-line-format (symbol-value irchat-pj-Channel-mode-line-format))
+  (setq major-mode 'irchat-Channel-mode
+	mode-name "IRC Current channel")
+  (irchat-pj-modeline-set
+   irchat-pj-modeline-local-status
+   irchat-pj-modeline-Channel-buffer
+   'irchat-pj-modeline-Channel)
   (use-local-map irchat-Channel-mode-map)
   (setq buffer-read-only t)
   (run-hooks 'irchat-Channel-mode-hook))
@@ -1211,8 +1193,7 @@
                                              (current-time-string))))
               (set-buffer obuf)))))
     ;; Update names lists
-    (if (or (not irchat-global-names)
-            (string-equal "A" irchat-away-indicator))
+    (if (or (not irchat-global-names) irchat-pj-away-p)
         ;; not polling or away, forget it
         nil
       ;; polling, see if enoung time has  passed since last poll, or this is 
diff -urN irchat-pj-2.4.24.21/make.el irchat-pj-2.4.24.22/make.el
--- irchat-pj-2.4.24.21/make.el	Fri Jul 19 02:18:53 2002
+++ irchat-pj-2.4.24.22/make.el	Sat Jul 20 20:29:42 2002
@@ -20,7 +20,7 @@
 					    (not (featurep 'mule))))
     "irchat-pj-coding-system.el"
     "irchat-pj-jisx0201.el"
-    "irchat-pj-mode-line-format.el"
+    "irchat-pj-modeline.el"
     "irchat-pj-version-string.el"
     "irchat-pj-sound.el"
     "irchat-pj-action.el"
diff -urN irchat-pj-2.4.24.21/shutup.el irchat-pj-2.4.24.22/shutup.el
--- irchat-pj-2.4.24.21/shutup.el	Tue Jan 25 18:04:15 2000
+++ irchat-pj-2.4.24.22/shutup.el	Sat Jul 20 21:20:24 2002
@@ -9,7 +9,7 @@
 (load-file "irchat-inlines.el")
 (load-file "irchat-pj-coding-system.el")
 (load-file "irchat-pj-jisx0201.el")
-(load-file "irchat-pj-mode-line-format.el")
+(load-file "irchat-pj-modeline.el")
 (load-file "irchat-pj-sound.el")
 (load-file "irchat-pj-version-string.el")
 (load-file "irchat-pj-sound.el")
@@ -33,14 +33,9 @@
 (defvar caesar-translate-table nil)
 (defvar fun nil)
 (defvar hook nil)
-(defvar irchat-away-indicator nil)
-(defvar irchat-beep-indicator-local nil)
 (defvar irchat-beep-local nil)
-(defvar irchat-freeze-indicator nil)
-(defvar irchat-freeze-indicator-local nil)
 (defvar irchat-freeze-local nil)
 (defvar irchat-hoge nil)
-(defvar irchat-suppress-indicator-local nil)
 (defvar irchat-suppress-local nil)
 (defvar lc-jp nil)
 (defvar mule-version nil)
@@ -78,6 +73,6 @@
     (defun char-charset (&rest args)))
 
 (and (fboundp 'char-bytes)
-     (eq 1 (char-bytes ?$(B$"(B))
+     (eq 1 (char-bytes ?$B$"(B))
      (get 'char-bytes 'byte-compile)
      (put 'char-bytes 'byte-compile nil))
